package p06_tablice;

import java.util.Arrays;
import java.util.stream.Stream;

public class A_Wstep {

    public static void main(String[] args) {
        // Zamiast tworzyć oddzielną zmienną dla każdej wartości:
        String imie1, imie2, imie3;
        imie1 = "Ala";
        imie2 = "Ola";
        imie3 = "Ula";
        System.out.println(imie1 + " " + imie2 + " " + imie3);
        
        // można utworzyć tablicę, która od razu zawiera wiele pól
        // (każde pole to tak jakby zmienna na pojedynczą wartość)
        String[] tablica = new String[5];
        tablica[1] = "Adam";
        tablica[2] = "Ludwik";
        tablica[3] = "Xawery";
        System.out.println(tablica[1] + " " + tablica[2] + " " + tablica[3]);

        // Możemy teraz używać operacji dotyczących całej tablicy łącznie:
        System.out.println(tablica);
        System.out.println(Arrays.toString(tablica));
        // okazuje się, że elementy tablic są numerowane od 0.
        // Ta tablica ma 5 elementów, więc poprawne indeksy (numery miejsc)
        // w tej tablicy to liczby od 0 do 4
        tablica[0] = "Andrzej";
        tablica[4] = "Zenon";
        System.out.println(Arrays.toString(tablica));
        System.out.println();
        
        // Można też używając pętli wykonywać czynności "dla każdego elementu tablicy"
        // pętla for z "licznikiem" - stary styl, ale na dużo pozwala
        for(int i=0; i < tablica.length; i++) {
            System.out.println("Osoba nr " + i + " ma imię " + tablica[i]);
        }
        System.out.println();
        
        // Od Java 5 mamy też pętlę for-each - najprostszy sposób odczytania wszystkich wartości
        for(String imie : tablica) {
            System.out.println("Witaj " + imie);
        }
        System.out.println();
        
        // Od Java 8 mamy też metodę forEach, do której przekazuje się wyrażenie lambda lub referencję do metody
        // (to by miało większy sens dla listy, a nie dla tablicy)
        Stream.of(tablica).forEach(imie -> System.out.println("Żegnaj " + imie));
    }

}
