package p08_funkcje;

public class A_Wprowadzenie {
    // Funkcja to jest fragment programu, któremu nadajemy jakąś nazwę
    // i używamy w programie wtedy, gdy nam jest potrzebny.
    static void aaa() {
        System.out.println("aaa, kotki dwa");
        System.out.println("szaro-bure obydwa");
    }
    
    // Funkcja może mieć zadeklarowane parametry
    // (w Javie musimy określić typy parametrów)
    // Funkcja widzi te parametry jako zmienne, którym nadane są początkowe wartości w momencie wywołania.
    static void powitaj(String imie, String miasto) {
        System.out.println("Witaj " + imie + " z miasta " + miasto);
    }
    
    // Funkcje typu void nie zwracają żadnego wyniku.
    
    // Jeśli funkcja ma inny typ, to MUSI zwrócić (return) wartość tego typu.
    static int stukrotnosc(int x) {
        return 100*x;
    }
    
    // Funkcja może mieć więcej niż 1 return. Ważne jednak, aby w każdym przebiegu zwróciła jakiś wynik.
    static String zgadnijPlec(String imie) {
        if(imie.endsWith("a")) {
            return "kobieta";
        } else {
            return "mężczyzna";            
        }
    }

    public static void main(String[] args) {
        System.out.println("Początek programu");
        aaa();
        aaa();
        System.out.println();
        powitaj("Ala", "Wrocław");
        powitaj("Łukasz", "Gdańsk");
        // wartości parametrów mogą pochodzić ze zmiennych, być obliczane itd.
        String osoba = "Ola Malinowska";
        String[] miasta = {"Gliwice", "Zabrze", "Katowice"};
        powitaj(osoba, miasta[1]);
        powitaj(osoba.split(" ")[0], miasta[2].toUpperCase());
        System.out.println();
        
        int wynik = stukrotnosc(7);
        System.out.println("Wynikiem funkcji stukrotnosc z parametrem 7 jest: " + wynik);
        // Gdy wywołamy funkcję, ale nie odbierzemy jej wyniku, to ten wynik nigdzie się nie pojawi; nigdzie się nie zapisze
        stukrotnosc(5);
        
        // Można bezpośrednio wypisać wynik:
        System.out.println(stukrotnosc(4));
        
        // Można użyć funkcji w wyrażeniach
        wynik = stukrotnosc(13) + stukrotnosc(4*2) * 2;
        System.out.println("Wynik wyrażenia: " + wynik);
        System.out.println();
        System.out.println(zgadnijPlec("Dominika"));
        System.out.println(zgadnijPlec("Patryk"));
        
        System.out.println("Koniec programu");
    }

}
