package p11_overloading;

public class PrzeciazanieTypowLiczbowych {
    
    static void print(Byte i) {
        System.out.println("Byte " + i);
    }
    
    static void print(int i) {
        System.out.println("int " + i);
    }
    
    static void print(String s) {
        System.out.println("String " + s);
    }
    
    static void print(Object o) {
        System.out.println("Obiekt klasy " + o.getClass().getSimpleName() + ", " + o);
    }
    
    public static void main(String[] args) {
        // przeciążanie / overloading to technika
        // pozwalająca napisać wiele metod o tej samej nazwie, które róznią się liczbą lub typem argumentów
        
        // to kompilator decyzuje o tym, która metoda zostanie użyta
        // na podstawie typu parametru
        print(13);
        print("ala");
        print('A'); // char pasuje do typu int
        
        // short jest poszerzany do typu int
        // technika "widening" (tylko dla typów prostych) - ona ma wyższy priorytet
        short sh = 10_000;
        print(sh);
        
        // long jest zamieniany na obiekt klasy Long i pasuje do metody typu Object
        // technika "boxing" - ona ma niższy priorytet niż widening
        long l = 10;
        print(l);

        // Tutaj będzie widać, że widening jest stosowany w pierwszej kolejności względem boxingu
        // byte bardziej pasuje to typu int, niż do typu Byte
        byte b = 127;
        print(b);
        
        Integer ii = 1024;
        // Tu zadziała Object, ale gdyby go nie było, to zadziałałby "unboxing" i zostałby użyty int.
        print(ii);

    }

}
